/*****************************************************************************************************/
//* HOW TO USE
//*
//*   INCLUDE JAVASCRIPT : Include //static.bricklink.com/renovate/js/module_wantedlistsaveas.js
//* 
//*   1. INIT With the title  ( CREATIOIN / COLLECTION / SHARED WANTEDLIST)  and  succeed callback function:   
//*			bl.wanted_list_save_as.init("CREATION", callbackfunction);    
//*   2. ADD Items : 
//*			bl.wanted_list_save_as.addItem(idItem, idColor, n4Qty, itemType);
//*	  3. DISP Modal :  condition will be "U", "N" or "X"
//*			bl.wanted_list_save_as.dispModal( strWantedListName , defaultImageUrl, condition);
//* 
/*****************************************************************************************************/
(
	function()
	{
		"use_strict";
		
		var blc_WantedListModal =
		{
			strWantedListType : "" 
		,	itemList: []
		,	wantedListTitle : ""
		,	wantedListName : ""
		,	uploadFrom : 1
		,	init:
			function( strWantedListSaveAsType, succeedCallback ) {
				this.strWantedListType = strWantedListSaveAsType;
				this.itemList = [];

				if (succeedCallback != null)
				{
					bl.wanted_list_save_as.wantedAddSucceedCallback = succeedCallback;
				}
			}

		,	onChangeItemCondition:
			function( condition ) {
				return;
			}
		,	addItem:
			function( idItem, idColor, qty, typeItem ) {
				this.itemList.push( {
					idItem : idItem,
					idColor : idColor,
					qty : qty,
					itemType: typeItem
				} )
			}
		,	wantedAddSucceedCallback:
			function() {
			}
		,	setUploadFrom:
			function(from) {
				this.uploadFrom = from;
			}
		,	dispModal:
			function(strWantedListName, strModelImgUrl, itemCondition )
			{
				if (blc_WantedListModal.itemList.length == 0)
				{
					alert("No Items Found");
					return;
				}
				
				if ( this.strWantedListType == "")
				{
					alert("List Type Error");
					return;
				}

				if ( !bl.session.is_loggedin )
				{
					alert( "You must login to add wanted list!" );
					return;
				}

				var dataSet = {
					strModelImgUrl: strModelImgUrl,
					strWantedListName: strWantedListName,
					itemCondition: itemCondition,
					strWantedListType: this.strWantedListType, 
					itemList: blc_WantedListModal.itemList,
					idUser: blo_session.user.user_no,
					wantedMore: null,
					uploadFrom: this.uploadFrom
				}

				$.ajax({
				  	url: '/ajax/clone/wanted/wantedmorelist.ajax',
				  	data: {userID: blo_session.user.user_no},
				  	type: 'POST',
				  	dataType: 'json',
				  	success: function(data){
						if (data.returnCode == 0){
							//console.log(data);
							dataSet.wantedMore = data.wantedMore;
							
							if ( typeof bl.wanted_list_save_as.showWantedListSaveAs === undefined || bl.wanted_list_save_as.showWantedListSaveAs == null )
							{
								$.getScript( "//static.bricklink.com/renovate/js/build/wantedlistSaveAs.build.js", function () { bl.wanted_list_save_as.showWantedListSaveAs( dataSet, blc_WantedListModal.statusCallback ); } );
							}
							else
							{
								bl.wanted_list_save_as.showWantedListSaveAs( dataSet, blc_WantedListModal.statusCallback );
							}
						}
					}

				});
			}
		,	statusCallback:
			function(errCode, errMsg, wantedMoreID)
			{
				if ( typeof bl.wanted_list_save_as.showWantedListSaveAsRes === undefined || bl.wanted_list_save_as.showWantedListSaveAsRes == null )
				{
					$.getScript( "//static.bricklink.com/renovate/js/build/wantedlistSaveAs.build.js", function () { bl.wanted_list_save_as.showWantedListSaveAsRes( errCode, errMsg, wantedMoreID ); } );
				}
				else
				{
					bl.wanted_list_save_as.showWantedListSaveAsRes( errCode, errMsg, wantedMoreID );
				}

				if (errCode == 0)
				{
					bl.wanted_list_save_as.wantedAddSucceedCallback();
				}
				
			}
		
		}

		bl.wanted_list_save_as =  blc_WantedListModal;
	}
)();